darcs

Issue 183 moves should appear in a replay-able order in --summary output

Title moves should appear in a replay-able order in --summary output
Priority bug Status resolved
Milestone Resolved in
Superseder Nosy List darcs-devel, dmitry.kurochkin, jch, kowey, markstos, thorkilnaur, tommy, vmiklos
Assigned To kowey
Topics UI

Created on 2006-06-05.23:44:55 by igloo, last changed 2010-04-02.20:52:44 by kowey.

Files
File name Uploaded Type Edit Remove
unnamed igloo, 2006-06-05.23:44:52 message/rfc822
Messages
msg694 (view) Author: igloo Date: 2006-06-05.23:44:52
No-one's defended the behaviour in the forwarded message, so I claim
that it is a bug.

Thanks
Ian
Attachments
msg697 (view) Author: jch Date: 2006-06-07.21:27:47
Here's the attachment, for the convenience of people using the bug tracker:

Hi all,

gen_summary at the bottom of PatchViewing.lhs seems to very deliberately
show all of the moves before everything else. This seems to have been
the case ever since it first showed moves:
darcs annotate --match='hash 20040622092818-53a90-c683ef72f83e38ad8c6bc4b5909233
e44b2d97b6'
Is there a reason for this?

It's causing problems for some people on IRC as they are doing things
with the output that don't like files being moved into directories before
the directory is created.


Thanks
Ian
msg2576 (view) Author: markstos Date: 2008-01-19.04:57:46
I confirmed the behavior still exists with Darcs2, but am re-classifying it as a
"wishlist" item, since I don't believe darcs ever claimed that the "summary"
output would appear in a re-playable order, although I agree that could make it
more intuitive or useful in some cases.
msg6989 (view) Author: kowey Date: 2009-01-05.17:50:35
Re-opening (to be overruled by Thorkil as needed, as I haven't checked the
details yet).

See http://bugs.darcs.net/issue1281 for evidence on why this could be considered
a bug and not just a feature request.
msg6991 (view) Author: vmiklos Date: 2009-01-05.17:56:29
Thanks. :)
msg8200 (view) Author: kowey Date: 2009-08-17.07:18:31
Note the closely related issue1519.

Whereas that bug deals with the sorting within move patches, this deals with the
sorting of the move patches themselves (ie. before all the hunks, etc).

OK, I think to fix this we need to do some more research and answer some questions:
 - why do we sort moves first? is it just to help coalescing somehow?
 - what would we lose by not doing this?

I imagine it's safe not to do, so maybe one approach would be to try NOT sorting
and see how that works out in practice.  In any case, this needs somebody to
pick up the bug and play with things...
msg8274 (view) Author: kowey Date: 2009-08-18.22:10:06
I think my patch will resolve this bug

Mon Aug 17 23:58:14 BST 2009  Eric Kow <kowey@darcs.net>
  * Resolve issue183: Do not sort changes --summary output.
  This adds move patches to our high-level representation of summary output.

But we need somebody (probably me) to write a regression test showing an example
of non-replayable output, eg with an adding a directory and moving a file into it.
msg10638 (view) Author: kowey Date: 2010-04-02.20:52:43
Test written and pushed (this was resolved a long time ago, just never
got around to writing that test)
History
Date User Action Args
2006-06-05 23:44:55igloocreate
2006-06-07 21:27:48jchsetstatus: unread -> unknown
nosy: + jch
messages: + msg697
2008-01-19 04:57:47markstossetpriority: bug -> wishlist
nosy: + markstos, kowey, beschmi
messages: + msg2576
title: Patch summaries and moves -> Wish: moves should appear in a replay-able order in --summary output
2008-02-11 01:05:21markstossetstatus: unknown -> deferred
nosy: droundy, jch, tommy, beschmi, kowey, markstos, igloo
2009-01-05 17:50:38koweysetpriority: wishlist -> bug
status: deferred -> unknown
title: Wish: moves should appear in a replay-able order in --summary output -> moves do not appear in a replay-able order in --summary output
messages: + msg6989
nosy: + vmiklos, dmitry.kurochkin, simon, thorkilnaur
2009-01-05 17:51:06koweysetpriority: bug -> feature
nosy: droundy, jch, tommy, beschmi, kowey, markstos, vmiklos, igloo, simon, thorkilnaur, dmitry.kurochkin
title: moves do not appear in a replay-able order in --summary output -> wish: moves should appear in a replay-able order in --summary output
2009-01-05 17:51:54koweylinkissue1281 superseder
2009-01-05 17:56:31vmiklossetnosy: droundy, jch, tommy, beschmi, kowey, markstos, vmiklos, igloo, simon, thorkilnaur, dmitry.kurochkin
messages: + msg6991
2009-05-13 08:11:22twbsetpriority: feature -> bug
nosy: droundy, jch, tommy, beschmi, kowey, markstos, vmiklos, igloo, simon, thorkilnaur, dmitry.kurochkin
2009-08-06 17:49:38adminsetnosy: + jast, Serware, darcs-devel, zooko, dagit, mornfall, - droundy, jch, vmiklos, igloo
2009-08-06 20:50:02adminsetnosy: - beschmi
2009-08-10 21:45:39adminsetnosy: + vmiklos, igloo, jch, - darcs-devel, zooko, jast, dagit, Serware, mornfall
2009-08-13 16:23:33koweylinkissue1519 superseder
2009-08-17 07:18:36koweysetstatus: unknown -> needs-reproduction
nosy: jch, tommy, kowey, markstos, vmiklos, igloo, simon, thorkilnaur, dmitry.kurochkin
topic: + Core
messages: + msg8200
title: wish: moves should appear in a replay-able order in --summary output -> moves should appear in a replay-able order in --summary output
2009-08-18 22:10:09koweysetnosy: jch, tommy, kowey, markstos, vmiklos, igloo, simon, thorkilnaur, dmitry.kurochkin
messages: + msg8274
assignedto: kowey
2009-08-25 17:18:57adminsetnosy: + darcs-devel, - igloo
2009-08-25 17:38:10adminsetnosy: - simon
2009-08-27 14:27:33adminsetnosy: jch, tommy, kowey, markstos, vmiklos, darcs-devel, thorkilnaur, dmitry.kurochkin
2010-04-02 20:52:44koweysetstatus: needs-reproduction -> resolved
topic: + UI, - Core
messages: + msg10638